#include <string>
#include <iostream> 
#include <sstream>
#include <vector>
#include <string>

using namespace std;


vector<string> tokenize(string ss)
{
	string tempString;
	stringstream lineStream(ss);
	vector<string> output;
	
	while (lineStream >> tempString)
	{
		output.push_back(tempString);
	}
	
	//testing---------------
	cout<<"TokenList: ";
	
	for (int i = 0; i <output.size(); ++i)
	{
		cout<<output[i]<<"  ";
	}
	//----------------------
	
	return output;
	
}

void displayTokenList(vector<string> input)
{
	cout<<"TokenList: "<<endl;
	for (int i = 0; i < input.size(); ++i)
	{
		cout<<input[i]<<endl;
	}
}


vector<string> insertCMD(vector<string> input)
{
	//relation name will be the first element of the vector of data returned by this function
	vector<string> output;
		
	if (input[0] == "INTO")
	{
		input.erase(input.begin());
		
		output.push_back(input[0]);		//pushing relation name
		
		input.erase(input.begin());
		
		if (input[0] == "VALUES" && input[1] == "FROM")
		{
			input.erase(input.begin());
			input.erase(input.begin());
			
			
			if(input[0] == "(")
			{			
				input.erase(input.begin());
				
				while(input[0] != ")")	//inserting all values to relation
				//for (int i = 0; i < 2; ++i)
				{
					if (input[0] == ",") input.erase(input.begin());
					
					output.push_back(input[0]);
					
					input.erase(input.begin());
				}
				
				return output;
				
			}
			
			else cout<<"Syntax error!"<<endl;
		}
		else cout<<"Syntax error!"<<endl;
		
	}
	
	else cout<<"Syntax error!"<<endl;
	
}

vector<string> showCMD(vector<string> input)
{
	if (input.size() > 3)
	{
		cout<<"Syntax error!"<<endl;
	}
				
	cout<<"\nPassing the following arguments to dbEngine: "<<endl;
	cout << "command :" << input[0] << endl;
	cout << "relation name / expression: "<< input[1] << endl;	
	
	return input;
}

vector<string> exitCMD(vector<string> input)
{
	if (input[1] != ";")
	{
		cout<<"ERROR: missing semicolon!"<<endl;
		return input;
	}
	
	if (input[0] != "EXIT") { 
		cout<<"Wrong function/syntax error!"<<endl;
		return input;
	}
	
	cout<<"Passing command: "<< input[0] <<endl;
	return input;
}


vector<string> createCMD(vector<string> input)
{
	if (input[0] != "CREATE") {
		cout << "Error: create keyword is missing." <<endl;
		return input;
	}
	
	cout << "\nPassing the following arguments to dbEngine: " << endl;
	// CREATE TABLE relation-name ( typed-attribute-list ) PRIMARY KEY ( attribute-list )
	cout << "command :" << input[0] << endl;
	cout << "argument: " << input[1] << endl;
	return input;
}

vector<string> openCMD(vector<string> input){
	if (input[0] != "OPEN") {
		cout << "Error: open keyword is missing." <<endl;
		return input;
	}
	
	cout << "\nPassing the following arguments to dbEngine: " << endl;
	cout << "command :" << input[0] << endl;
	cout << "relation: " << input[1] << endl;
}

vector<string> closeCMD(vector<string> input){
	if (input[0] != "CLOSE") {
		cout << "Error: close keyword is missing." <<endl;
		return input;
	}
	
	cout << "\nPassing the following arguments to dbEngine: " << endl;
	cout << "command :" << input[0] << endl;
	cout << "relation: " << input[1] << endl;
	return input;
}

vector<string> saveCMD(vector<string> input){
	if (input[0] != "SAVE") {
		cout << "Error: save keyword is missing." <<endl;
		return input;
	}
	
	cout << "\nPassing the following arguments to dbEngine: " << endl;
	cout << "command :" << input[0] << endl;
	cout << "relation: " << input[1] << endl;
	return input;
}

vector<string> updateCMD(vector<string> input){
	//UPDATE relation-name SET attribute-name = literal { , attribute-name = literal } WHERE condition 
}

vector<string> deleteCMD(vector<string> input){
	//DELETE FROM relation-name WHERE condition
	if (input[0] != "DELETE") {
		cout << "Error: save keyword is missing." <<endl;
		return input;
	}
	
	cout << "\nPassing the following arguments to dbEngine: " << endl;
	cout << "command :" << input[0] << endl;
	cout << "relation: " << input[2] << endl;
	cout << "condition: " << input[5] << input[6] << input[7] << endl;
	
	return input;
}

int main () {
	string s = "DELETE FROM animals WHERE ( age == 12 ) ;";
	
	vector<string> listOfTokens = tokenize(s);
	deleteCMD(listOfTokens);
}